package api

import (
	"fmt"

	"github.com/gin-gonic/gin"
)

// RegRouters 注册路由
func RegRouters(svc *Service) {

	svc.Gin.Use(Logger())

	//登录
	spud3dGroup := svc.NewGinRouter("/sku3dsite")

	spud3dGroup.POSTJWT("/login/succ", ServiceLoginSucc)

	//数据存储
	spud3dGroup.POSTJWTTest("/data/image/policy", ServiceObsCreateImagePolicy)
	// spud3dGroup.GETJWT("/obs/list", ServiceObsList)
	spud3dGroup.POSTJWT("/obs/upload", ServiceObsUploadPolicy)
	// spud3dGroup.POSTJWT("/obs/delete", ServiceObsRemove)
	// spud3dGroup.POSTJWT("/obs/folder", ServiceObsCreateFolder)

	//minio
	spud3dGroup.POSTJWT("/minio/policy", MinioCreateUserPolicy)

	//资源路由管理
	CreateWebRouter(spud3dGroup)

	RegMeshCrud(spud3dGroup)

	RegMatCrud(spud3dGroup)

	//web端
	// spud3dGroup.POST("/web/login/password", ServiceUserLoginPassword)
	// spud3dGroup.POST("/web/sms", ServiceSmsSend)
	// spud3dGroup.POST("/web/login/sms", ServiceUserLoginSms)
	// spud3dGroup.POSTJWT("/web/login/switch", ServiceLoginSwitchParent)

	// spud3dGroup.POSTJWT("/web/user/loginout", ServiceWebUserLoginout)
	// spud3dGroup.GETJWT("/web/user/profile", ServiceWebUserProfile)
	// spud3dGroup.POSTJWT("/web/user/profile", ServiceWebUserUpdateProfile)
	// spud3dGroup.POSTJWT("/web/user/resetpwd", ServiceWebUserResetPwd)

	// spud3dGroup.POSTJWT("/web/user/editset", ServiceWebUserUpdateEditSet)
	// spud3dGroup.POSTJWT("/web/user/editset/basecolor", ServiceWebUserUpdateEditSetBaseColor)
	// spud3dGroup.POSTJWT("/web/user/editset/defaultEnv3d", ServiceWebUserUpdateEditSetDefaultEnv3d)

	// spud3dGroup.POSTJWT("/design/create", ServiceDesignCreate)
	// spud3dGroup.POSTJWT("/design/resetshoe", ServiceDesignResetShoe)
	// spud3dGroup.POSTJWT("/design/resetdesign", ServiceDesignResetDesign)

	// spud3dGroup.POSTJWT("/design/update/:id", ServiceDesignUpdate)

	spud3dGroup.GETJWT("/design/list", ServiceDesignList)
	spud3dGroup.GET("/design/public", ServiceDesignPublicList)

	// spud3dGroup.POSTJWT("/design/delete/:id", ServiceDesignDelete)
	// spud3dGroup.POSTJWT("/design/scene/create/:id/:scope", ServiceDesignCreateScene)
	// spud3dGroup.POSTJWT("/design/scene/update/:id/:scope", ServiceDesignUpdateScene)
	// spud3dGroup.POSTJWT("/design/scene/delete/:id/:scope", ServiceDesignRomoveScene)
	// spud3dGroup.POSTJWT("/design/rename/:id", ServiceDesignRename)

	// spud3dGroup.POSTJWT("/design/scene/thumbnail/:id", ServiceDesignSceneThumbnail)
	// spud3dGroup.POSTJWT("/design/public/:id", ServiceDesignPublic)
	// spud3dGroup.POSTJWT("/design/copy/:id", ServiceDesignCopy)

	spud3dGroup.GET("/design/share", ServiceShareDesign)
	spud3dGroup.GET("/design/detail/:id", ServiceDesignDetail)

	spud3dGroup.POSTJWT("/design/scene/render", ServiceTaskCreate)

	spud3dGroup.GETJWT("/task/list/:id", ServiceTaskList)
	spud3dGroup.GETJWT("/task/detail/:id", ServiceTaskDetail)
	spud3dGroup.POSTJWT("/task/remove/:id", ServiceTaskRemove)

	CreateBackgroundRouter(spud3dGroup)

	// spud3dGroup.POST("/hdr/conv", ServiceConvHdr)

	RegAdminRouter(spud3dGroup)

	RegAdminActionRouter(spud3dGroup)

	CreateCatRouter(spud3dGroup)
	CreatePermsRouter(spud3dGroup)

	CreateQiyeUserRouter(spud3dGroup)
	CreateUserUploadRouter(spud3dGroup)

	CreateLibRouter(spud3dGroup)

	CreateUserCamerasRouter(spud3dGroup)

	RegisterTeamLib(spud3dGroup)

	RegCollocateRouter(spud3dGroup)

	RegImageMat(spud3dGroup)

	// 会员
	Member(spud3dGroup)

	// 会员用户
	MemberUser(spud3dGroup)

	// 会员申请
	Order(spud3dGroup)
	// for _, proxy := range svc.Conf.Proxies {
	// 	spud3dGroup.group.GET(proxy.Prefix, utils.CreateServiceProxy(proxy))
	// 	spud3dGroup.group.POST(proxy.Prefix, utils.CreateServiceProxy(proxy))
	// }
	Queentree(spud3dGroup)

	CreateUserSettingRouter(spud3dGroup)

	RegTree(spud3dGroup)

	RegTreeAssetOps(spud3dGroup)

	RegTreeAssetRemove(spud3dGroup)

	regAssetUpdator(spud3dGroup)

	RegShareApis(spud3dGroup)

	RegQueenterApis(spud3dGroup)

	// !20241220新增
	// 分类管理
	spud3dGroup.POSTJWT("/im/cate/create", CategoryCreate)
	spud3dGroup.POSTJWT("/im/cate/delete/:id", DeleteCategory)
	spud3dGroup.GETJWT("/im/cate/list", CategoryList)
	spud3dGroup.POSTJWT("/im/cate/update", UpdateCategory)

	// 素材管理
	spud3dGroup.POSTJWT("/im/material/create", CreateMaterial)
	spud3dGroup.POSTJWT("/im/material/delete/:id", DeleteMaterial)
	spud3dGroup.GETJWT("/im/material/list", MaterialList)
	spud3dGroup.POSTJWT("/im/material/update", UpdateMaterial)

	// 图片搜索新增
	spud3dGroup.POSTJWT("/tree/:assetType/u2m/:id", updateToMilvus)
	spud3dGroup.POSTJWT("/tree/:assetType/search/image", searchToMilvus)
}

func Logger() gin.HandlerFunc {

	return func(c *gin.Context) {
		// 开始时间
		// start := time.Now()
		// 处理请求
		c.Next()
		// 结束时间
		// end := time.Now()
		//执行时间
		// latency := end.Sub(start)

		path := c.Request.URL.Path

		clientIP := c.ClientIP()
		// method := c.Request.Method
		// statusCode := c.Writer.Status()

		out := fmt.Sprintf("%15s=> %s", clientIP, path)
		fmt.Println(out)
	}
}
