package bus

import (
	"assetcenter/conf"

	"infish.cn/comm"
)

var NatsCenter *comm.NatsBus

func NewNatsBus(app *conf.AppConf) *comm.NatsBus {

	bus, _ := comm.NewNatsBus2(app.Nats.Url, app.Nats.MaxReconnect,
		app.Nats.ReconnDelaySecond,
		[]*comm.NatsStreamWather{
			CreateOsgConvResultWather(app),
			CreateShadowResultWather(app),
			// CreateHdrResultWather(app),
		},
		[]*comm.NatsMsgReplyer{
			newReplayer(),
			addTreeDefineMatgroup(),
			removeTreeDefineMatgroup(),

			addTreeDefineMeshpack(),
			removeTreeDefineMeshpack(),
			RegTreeCategoryQuery(),
			RegTreeAssetAddMatgroup(),
			RegTreeAssetDetailMatgroup(),
			RegTreeAssetDetailMeshPack(),
			RegTreeDbCategoriesQuery(),

			RegTreeAssetList(),
			RegTreeUserCategoryUpdate(),
			RegTreeUserAssetCategoryUpdate(),
			RegTreeUserAssetCategoryQuery(),
			RegTreeDbAssetsQuery(),
			RegTreeDbAssetsUpdate(),
			RegTreeDbCategoriesUpdate(),

			RegTreeAssetInsert(),
			RegTreeAssetPackDetail(),
			RegTreeAssetMatgroupDetail(),
			RegTreeAssetImageDetail(),
			RegTreeAssetRemove(),
			RegTreeAssetDetail(),

			RegTreeAssetUpdate(),
			RegTreeAssetPackProcess(),
			RegTreeAssetCreate(),

			RegTreeAssetRecreateShadow(),

			// 图片搜索
			RegTreeSearchImage(),
		})
	NatsCenter = bus

	return NatsCenter
}
