package model

import "go.mongodb.org/mongo-driver/bson/primitive"

type AppAssetDef struct {
	Name         string //资产名字
	Desc         string //资产使用简介
	Type         int    //资产类型
	DbId         string //数据库Id
	CollectionId string //数据表Id
}

type Database3dApp struct {
	Id                       primitive.ObjectID `bson:"_id,omitempty" json:"_id"`                                     //
	Name                     string             `bson:"name,omitempty" json:"name"`                                   //应用名字
	AppIcon                  string             `bson:"appIcon,omitempty" json:"appIcon"`                             //应用图标
	Desc                     string             `bson:"desc,omitempty" json:"desc"`                                   //应用描述
	HomePageUrl              string             `bson:"homepageUrl,omitempty" json:"homepageUrl"`                     //应用网页地址
	AuthorizationCallbackUrl string             `bson:"authorizedCallbackUrl,omitempty" json:"authorizedCallbackUrl"` //授权后回调地址

	AppKey     string `bson:"appKey,omitempty" json:"appKey"`
	AppSecrete string `bson:"appSecrete,omitempty" json:"appSecrete"`

	//输入资产定义
	InputAssetConfs []*AppAssetDef `bson:"inputAssetConfs,omitempty" json:"inputAssetConfs"`

	//输出资产定义
	OutputAssetConfs []*AppAssetDef `bson:"outputAssetConfs,omitempty" json:"outputAssetConfs"`
}

var Spu3dApp = &Database3dApp{
	InputAssetConfs: []*AppAssetDef{
		&AppAssetDef{
			Name:         "盒型",
			DbId:         "001",
			CollectionId: "1111",
		}, &AppAssetDef{
			Name:         "场景",
			DbId:         "001",
			CollectionId: "1111",
		},
	},
}

type UserAssetOAuths struct {
	Id               primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	UserId           primitive.ObjectID `bson:"userId,omitempty" json:"userId"`
	AppId            primitive.ObjectID `bson:"appId,omitempty" json:"appId"`
	InputAssetConfs  []*AppAssetDef     `bson:"inputAssetConfs,omitempty" json:"inputAssetConfs"`
	OutputAssetConfs []*AppAssetDef     `bson:"outputAssetConfs,omitempty" json:"outputAssetConfs"`
}
