package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

type Env3d struct {
	Id         primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	UserId     primitive.ObjectID `bson:"userId,omitempty" json:"userId,omitempty"`
	Name       string             `bson:"name,omitempty" json:"name"`
	Thumbnail  *OssType           `bson:"thumbnail,omitempty" json:"thumbnail"`
	CreateTime time.Time          `bson:"createTime,omitempty" json:"createTime"`
	UpdateTime time.Time          `bson:"updateTime,omitempty" json:"updateTime"`
	State      int                `bson:"state,omitempty" json:"state"` //created completed published

	HDR    *OssType      `bson:"hdr,omitempty" json:"hdr"`
	Config *Evn3dHdrConf `bson:"config,omitempty" json:"config"`

	Options *Env3dOption `bson:"options,omitempty" json:"options"`

	ToneMap *ToneMap `bson:"toneMap,omitempty" json:"toneMap"`

	Background *Evn3dBackground `bson:"background,omitempty" json:"background"`
}

type Env3dConfig struct {
	Id primitive.ObjectID `bson:"_id,omitempty" json:"_id"`

	Name       string    `bson:"name,omitempty" json:"name"`
	Thumbnail  *OssType  `bson:"thumbnail,omitempty" json:"thumbnail"`
	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime"`
	UpdateTime time.Time `bson:"updateTime,omitempty" json:"updateTime"`

	HDR     *OssType      `bson:"hdr,omitempty" json:"hdr"`
	Config  *Evn3dHdrConf `bson:"config,omitempty" json:"config"`
	Options *Env3dOption  `bson:"options,omitempty" json:"options"`
}

type Evn3dBackground struct {
	Color *Vect3   `bson:"color,omitempty" json:"color"`
	Image *OssType `bson:"image,omitempty" json:"image"`
	Type  int32    `bson:"type,omitempty" json:"type"`
}
