package funcgraph

import (
	"assetcenter/conf"
	"fmt"
	"strings"

	"github.com/huaweicloud/huaweicloud-sdk-go-v3/services/functiongraph/v2/model"
)

func CreateHdr(fileUrl string, assetId string, dbId string, table string, natsUrl string) error {

	client := createFuncGraphClient()
	streamTopic := conf.AppConfig.Nats.HdrConvStreamTopic
	streamTopics := strings.Split(streamTopic, "#")

	request := &model.AsyncInvokeFunctionRequest{Body: map[string]interface{}{
		"meshUrl":       fileUrl,
		"assetId":       assetId,
		"dbId":          dbId,
		"table":         table,
		"notifyNatsUrl": natsUrl,
		"notifyStream":  streamTopics[0],
		"notifySubject": streamTopics[1],
	}}

	request.FunctionUrn = "urn:fss:cn-east-3:0956c65fd600f29f2ff6c00dbb3d1e2e:function:default:hdrconv:latest"
	response, err := client.AsyncInvokeFunction(request)
	if err == nil {
		fmt.Printf("%+v\n", response)
		return nil
	}
	fmt.Println("CreateHrc Function Graph call failed=>", err.Error())

	return err
}
